/**
 * Redistribution and use of this software and associated documentation
 * ("Software"), with or without modification, are permitted provided
 * that the following conditions are met:
 *
 * 1. Redistributions of source code must retain copyright
 *    statements and notices.  Redistributions must also contain a
 *    copy of this document.
 *
 * 2. Redistributions in binary form must reproduce the
 *    above copyright notice, this list of conditions and the
 *    following disclaimer in the documentation and/or other
 *    materials provided with the distribution.
 *
 * 3. The name "Exolab" must not be used to endorse or promote
 *    products derived from this Software without prior written
 *    permission of Intalio, Inc.  For written permission,
 *    please contact info@exolab.org.
 *
 * 4. Products derived from this Software may not be called "Exolab"
 *    nor may "Exolab" appear in their names without prior written
 *    permission of Intalio, Inc. Exolab is a registered
 *    trademark of Intalio, Inc.
 *
 * 5. Due credit should be given to the Exolab Project
 *    (http://www.exolab.org/).
 *
 * THIS SOFTWARE IS PROVIDED BY INTALIO, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * INTALIO, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Copyright 1999, 2000 (C) Intalio, Inc. All Rights Reserved.
 *
 * $Id: AbstractXMLNaming.java 8034 2009-01-26 00:59:04Z rjoachim $
 */
package org.exolab.castor.xml;

import org.castor.xml.BackwardCompatibilityContext;
import org.castor.xml.XMLNaming;

/**
 * An abstract class to handing XML naming
 * @author <a href="mailto:kvisco@intalio.com">Keith Visco</a>
 * @version $Revision: 8034 $ $Date: 2003-09-12 03:23:33 -0600 (Fri, 12 Sep 2003) $
**/
public abstract class AbstractXMLNaming implements XMLNaming {


    //--------------------/
    //- Abstract Methods -/
    //--------------------/
    
    /* (non-Javadoc)
	 * @see org.exolab.castor.xml.XMLNaming#createXMLName(java.lang.Class)
	 */
    public abstract String createXMLName(Class c);

    
    /* (non-Javadoc)
	 * @see org.exolab.castor.xml.XMLNaming#toXMLName(java.lang.String)
	 */
    public abstract String toXMLName(String name);
    
    
    /**
     * Returns the default instance of XMLNaming.
     * @see org.exolab.castor.util.AbstractProperties
    **/
    public static final XMLNaming getInstance() {
        return new BackwardCompatibilityContext().getXMLNaming(); 
    } //-- getInstance
    
} //-- Naming
